/*
modulo: CMESE.C
scopo: cambio del formato del mese da numerico ad alfabetico
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127

char *nome_mese (const int n_mese)
{
  static char *mtab[] = {
    "(mese inesistente)",
    "Gennaio",
    "Febbraio",
    "Marzo",
    "Aprile",
    "Maggio",
    "Giugno",
    "Luglio",
    "Agosto",
    "Settembre",
    "Ottobre",
    "Novembre",
    "Dicembre"
    };
  static int max_mtab = sizeof(mtab) / sizeof(mtab[0]);

  if (n_mese > 0 && n_mese < max_mtab)
    return mtab[n_mese];
  else
    return mtab[0];
}


int main ()
{
  char buf[MAXBC+1];
  int g, m, a;

  while (gets(buf) != NULL) {
    if (sscanf(buf,"%d.%d.%d",&g,&m,&a) != 3)
      fprintf (stderr, "errore - formato di data sbagliato (%s)\n", buf);
    else
      printf ("%d %s %d\n", g, nome_mese(m), a);
  }
  return 0;
}
