#include <stdio.h>

#define MAXBC 127

int main (int argc, char *argv[])
{
  int n, righe_copiate;
  FILE *afh;
  FILE *bfh;
  char buf[MAXBC+1];

  if (argc != 4) {
    fprintf (stderr, "errore: inserire numero di righe da copiare e nomi di due file\n");
    return 1;
  }

  if (sscanf(argv[1],"%d",&n) != 1) {
    fprintf (stderr, "errore: il parametro (%s) non e' un numero intero\n", argv[1]);
    return 2;
  }

  if ((afh = fopen (argv[2], "r")) == NULL) {
    fprintf (stderr, "errore: impossibile aprire il file '%s' in lettura\n", argv[2]);
    return 3;
  }
  if ((bfh = fopen (argv[3], "w")) == NULL) {
    fprintf (stderr, "errore: impossibile aprire il file '%s' in scrittura\n", argv[3]);
    return 4;
  }

  righe_copiate = 0;

  while ( (fgets(buf,MAXBC+1,afh) != NULL) && (righe_copiate < n) )
  {
    if (fputs (buf, bfh) == EOF) {
      fprintf (stderr, "errore - non riesco a scrivere sul file '%s'\n", argv[3]);
      return 5;
    }
    righe_copiate++;
  }

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s'\n", argv[2]);
  if (fclose(bfh) != 0) {
    fprintf (stderr, "avviso: non sono riuscito a chiudere il file '%s';", argv[3]);
    fprintf (stderr, " la copia potrebbe non essere riuscita\n");
  }

  if (righe_copiate < n)
    fprintf (stderr, "avviso: copiate solo %d righe (invece di %d)\n", righe_copiate, n);

  return 0;
}
