#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXBC 127


void centra_e_stampa (char *riga, int lriga, int lmax)
{
   int i;

   for (i=0; i < (lmax-lriga)/2; i++)
     putchar (' ');
   printf ("%s\n", riga);
}


void stampa (char *s, int l)
{
  int i;

  for (i=0; i<l; i++)
    putchar (s[i]);
  putchar ('\n');
}


int main (int argc, char *argv[])
{
  FILE *afh, *bfh;
  char buf[MAXBC+1];
  int lm;

  /* controllare e leggere i parametri */

  if (argc != 4) {
    fprintf (stderr, "errore - inserire tre parametri\n");
    exit (1);
  }

  if (sscanf(argv[3],"%d",&lm) != 1 || lm<=0 || lm>MAXBC-1) {
    fprintf (stderr, "errore - il terzo parametro (%s) non e' un intero positivo\n",
      argv[3]);
    exit (2);
  }

  /* aprire i file */

  if ((afh=fopen(argv[1],"r")) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in lettura\n", argv[1]);
    exit (3);
  }

  if ((bfh=fopen(argv[2],"w")) == NULL) {
    fprintf (stderr, "errore - impossibile aprire il file '%s' in scrittura\n", argv[2]);
    exit (4);
  }

  /* leggere tutte le righe ... e per ogni riga */

  while (fgets(buf,MAXBC+1,afh) != NULL)
  {
    /* centra e stampa la riga */

    int lriga = strlen(buf);

    lriga--;
    buf[lriga] = '\0';

    if (lriga <= lm)
      centra_e_stampa (buf, lriga, lm);
    else
    {
      int inizio = 0;
      while (strlen(&buf[inizio]) >= lm)
      {
        stampa (&buf[inizio], lm);
        inizio += lm;
      }
      if (strlen(&buf[inizio]) > 0)
        centra_e_stampa (&buf[inizio], strlen(&buf[inizio]), lm);
    }

  }

  /* chiudere i file */

  if (fclose(afh) != 0)
    fprintf (stderr, "avviso - non sono riuscito a chiudere il file '%s'\n", argv[1]);

  if (fclose(bfh) != 0)
    fprintf (stderr, "avviso - non sono riuscito a chiudere il file '%s'\n", argv[2]);

  return 0;
}
