/**************************************

MODULO: r4.c

SCOPO: calcolo radice quarta (del numero
introdotto sulla riga di comando)

**************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>


int main (int argc, char *argv[])
{
  double num;

  /* controllo che il numero sia stato inserito */

  if (argc != 2)
  {
    fprintf (stderr, "errore - inserire il numero\n");
    exit (1);
  }

  /* leggo il numero e controllo che sia un float non negativo */

  if (sscanf(argv[1],"%lf",&num) != 1)
  {
    fprintf (stderr, "errore - il valore inserito (%s) non e' un numero\n", argv[1]);
    exit (2);
  }
  if (num < 0)
  {
    fprintf (stderr, "errore - il valore inserito (%s) e' negativo\n", argv[1]);
    exit (3);
  }

  /* calcolo e stampo la radice quarta */

  printf ("radice quarta di %lf = %lf\n", num, pow(num,0.25));

  return 0;
}
