#include <stdio.h>
#include <stdlib.h>

int main ( int argc, char *argv[] )
{
  const char white = ' ';
  const char EOL = '\n';

  char black;
  int riga, colonna, lato;
  enum {BIANCO, NERO} stato_colonna, stato_riga;

  if (argc != 3)
  {
    fprintf (stderr, "errore - fornire due parametri\n");
    exit (1);
  }

  if (sscanf (argv[1],"%d", &lato) != 1)
  {
    fprintf (stderr, "errore - il parametro (%s) non e' un numero intero\n", argv[1]);
    exit (2);
  }

  if ( sscanf (argv[2], "%c", &black) != 1)
  {
    fprintf (stderr, "errore\n");
    exit (3);
  }

  /* comincio con una riga che ha la prima casella bianca */

  stato_riga = BIANCO;

  for (riga=1; riga<=lato; riga++)
  {
    /* come deve iniziare questa riga? */

    switch (stato_riga)
    {
    case BIANCO:
      stato_colonna = BIANCO;
      stato_riga = NERO;
      break;
    case NERO:
      stato_colonna = NERO;
      stato_riga = BIANCO;
      break;
    default:
      fprintf (stderr, "bug - stato impossibile\n");
      exit (4);
    }

    /* stampo le colonne della presente riga */

    for (colonna=1; colonna<=lato; colonna++)
    switch (stato_colonna)
    {
    case BIANCO:
      putchar (white);
      stato_colonna = NERO;
      break;
    case NERO:
      putchar (black);
      stato_colonna = BIANCO;
      break;
    default:
      fprintf (stderr, "bug - stato impossibile\n");
      exit (4);
    }

    /* stampo fine riga */

    putchar (EOL);
  }

  return 0;
}
