/*
variante del tema d'esame del 27/1/2010 in cui le misure dei singoli pezzi
possono avere un ordine diverso rispetto al file MISURE
(e quindi la valutazione deve essere fatta in base al nome della singola misura)
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define MISURE "misure.txt"
#define MAXBC 127
#define MAXNOME 6
#define MAXMISURE 10

#define BOOL int
#define FALSE 0
#define TRUE (!FALSE)

struct _misura
{
   char nome[MAXNOME+1];
   double misuranominale;
   double tolleranza;
};

struct _misurapezzo
{
   char nome[MAXNOME+1];
   double misuraeffettiva;
};

typedef struct _misura misura;
typedef struct _misurapezzo misurapezzo;

int main (int argc,char *argv[])
{
   FILE *afh,*bfh;
   char buf[MAXBC+1];
   int k, i;
   misura misura[MAXMISURE];
   misurapezzo misurapezzo[MAXMISURE];
   BOOL conforme;

   if(argc!=2) {
       fprintf (stderr, "errore - inserire il nome di un file\n");
       exit (1);
   }
   if ((afh=fopen(MISURE,"r")) == NULL) {
      fprintf (stderr, "errore - impossibile aprire il file '%s' in lettura\n", MISURE);
       exit (2);
   }
   if ((bfh=fopen(argv[1],"r")) == NULL) {
      fprintf (stderr, "errore - impossibile aprire il file '%s' in lettura\n", argv[1]);
      exit (3);
   }

   if (fgets(buf,MAXBC+1,afh) == NULL) {
       fprintf (stderr, "errore nella lettura del numero di dimensioni\n");
       exit (4);
   }

   if (sscanf(buf,"%d",&k) != 1) {
      fprintf(stderr,"errore nella lettura del numero di dimensioni\n");
      exit (5);
   }

   /* lettura delle misure nominali */

   for (i=0; i<k; i++)
   {
      if (fgets(buf,MAXBC+1,afh) == NULL) {
         fprintf(stderr,"errore nella lettura della misura n.%d\n", i+1);
         exit (5);
      }
      if (sscanf(buf,"%s %lf %lf",misura[i].nome,&misura[i].misuranominale,&misura[i].tolleranza) != 3) {
         fprintf (stderr,"errore nella lettura della misura n.%d\n", i+1);
         exit (6);
      }
   }

   /* lettura delle misure effettive */

   for (i=0; i<k; i++)
   {
      if (fgets(buf,MAXBC+1,bfh) == NULL) {
         fprintf(stderr,"errore nella lettura della misura n.%d\n", i+1);
         exit (5);
      }
      if (sscanf(buf,"%s %lf",misurapezzo[i].nome,&misurapezzo[i].misuraeffettiva) != 2) {
         fprintf(stderr,"errore nella riga %d del file %s\n", i+1, argv[1]);
         exit(7);
      }
    }

   /* verifica di conformita' */

   conforme=TRUE;
   for (i=0; i<k; i++)
   {
      int j;
      for (j=0; j<k; j++)
      {
         if (strcmp(misurapezzo[i].nome,misura[j].nome) == 0)
         {
            if ( fabs(misurapezzo[i].misuraeffettiva - misura[j].misuranominale)
                 > misura[j].tolleranza)
            {
               printf ("valore di %s non conforme\n", misura[i].nome);
               conforme = FALSE;
            }
            break;
         }
      }
   }

   if (conforme)
      printf ("pezzo conforme\n");

   return 0;
}
